
% 1 = Origin, 2 = U, 3 = V, 4 = data
\newcommand{\mlhpMatrix}[4]
{
  % Determine y shift from outer list length
  \foreach [count=\i from 0] \List in {#4}%
  {%
    \coordinate (ShiftY) at ($\i/2*(#3)$);%
  }%

  \foreach[count=\i from 0] \List in {#4}%
  {%
    % Determine center from inner list length
    \foreach [count=\j from 0] \Entry in \List%
    {%
      \coordinate (Center) at ($(#1) + (ShiftY) - \j/2*(#2)$);
    }%

    \foreach [count=\j from 0] \Entry in \List%
    {%
      \node at ($(Center) + \j*(#2) - \i*(#3)$) {\footnotesize \Entry};%
    }%
  }%
}%

% 1 -> size1, 2 -> size2, 3 -> size3, 4 -> origin, 5 -> (dx), 6 -> (dy), 7 -> (dx), 8 -> data
\newcommand\drawThreeDimensionalMask[8]
{
  \coordinate (O) at (#4);
  
  \coordinate (dx) at (#5);
  \coordinate (dy) at (#6);
  \coordinate (dz) at (#7);
    
  \def\dxLength{0.12cm};
  \def\dzLength{0.11cm};
  \def\dyFactor{0.3};

  % Print entries
  \foreach[count=\i] \List in {#8}
  {
    \foreach[count=\j] \Entry in \List
    {
      \pgfmathsetmacro\right{\j > #1 ? \j - #1 : 0};
    
      \pgfmathsetmacro\x{\j - 1 - \right};
      \pgfmathsetmacro\y{\i > #2 ? \right : #2 - \i + \right};
      \pgfmathsetmacro\z{\i <= #2 ? #3 - 1 - \right : #3 + #2 - 1 - \i - \right};
    
      \node at ($(O) + \x*(dx) + \y*(dy) + \z*(dz)$) {\footnotesize \Entry};
    }
  }
  
  % horizontal connection lines
  \foreach \i in {2,...,#1}
  {
    \foreach \P in {($(O) + {(\i - 1.5)}*(dx)$), 
                    ($(O) + {(\i - 1.5)}*(dx) + {(#3 - 1)}*(dz)$),
                    ($(O) + {(\i - 1.5)}*(dx) + {(#3 - 1)}*(dz) + {(#2 - 1)}*(dy)$)}
    {
      \node[coordinate] (T) at \P {};
  
      \draw ([xshift=-\dxLength/2]T) -- ([xshift=\dxLength/2]T);
    }
  }
  
  % vertical connection lines
  \foreach \i in {2,...,#3}
  {
    \foreach \P in {($(O) + {(\i - 1.5)}*(dz)$), 
                    ($(O) + {(\i - 1.5)}*(dz) + {(#1 - 1)}*(dx)$),
                    ($(O) + {(\i - 1.5)}*(dz) + {(#1 - 1)}*(dx) + {(#2 - 1)}*(dy)$)}
    {
      \node[coordinate] (T) at \P {};
  
      \draw ([yshift=-\dzLength/2]T) -- ([yshift=\dzLength/2]T);
    }
  }
  
  % skew connection lines
  \foreach \i in {2,...,#2}
  {
    \foreach \P in {($(O) + {(\i - 1.5)}*(dy) + {(#3 - 1)}*(dz)$), 
                    ($(O) + {(\i - 1.5)}*(dy) + {(#1 - 1)}*(dx)$),
                    ($(O) + {(\i - 1.5)}*(dy) + {(#3 - 1)}*(dz) + {(#1 - 1)}*(dx)$)}
    {
      \node[coordinate] (T) at \P {};
  
      \draw ($(T) - \dyFactor/2*(dy)$) -- ($(T) + \dyFactor/2*(dy)$);
    }
  }
}

% Shape functions for plots in chapters 2, 3 and 4
% #1: Lower left corner coordinate
% #2: Type (small, mlhpA, ...)
% #3: Color_Index (green_01, gray_22, ...)
\newcommand{\includeShape}[3]{
    \ifthenelse{\NOT\equal{#3}{none}}{\node[anchor=south west, inner sep=0pt, outer sep=0pt] at (#1) 
            {\includegraphics{chapters/shapefunctions/pdf/#2_#3.pdf}};}{}}

% Grid of shape functions
% #1: Lower left corner coordinate
% #2: U-Vector (width of shape functions)
% #3: V-Vector (height of shape functions)
% #4: Horizontal gap vector
% #5: Vertical gap vector
% #6: Shape function type (small, mlhpA, ...)
% #7: Shape indices as list of lists
\newcommand{\drawShapes}[7]
{
  % Determine coordinate of upper left picture
  \foreach [count=\I from 0] \IndexList in #7
    \coordinate (UpperLeft) at ($(#1) - 0.5*(#3) + \I*(#3) + {\I + 1}*(#5) + (#4)$);

  % Add pictures back to front
  \foreach [count=\I from 0] \IndexList in #7
  {
    \foreach [count=\J from 0] \ShapeIndex in \IndexList
    {
        \includeShape{$(UpperLeft) - \I*(#3) - \I*(#5) + \J*(#2) + \J*(#4)$}{#6}{\ShapeIndex}
    }
  }
}

% Setup a grid of shape function grids, mostly for p-fem examples
\newcommand{\defineShapes}[5]
{
    \def\width{#3*478pt}
    
    \coordinate (U) at (2/3*\width, 0);
    \coordinate (V) at (2/15*\width, 0.4*\width);
    \coordinate (W) at ($-0.21*(U) + 0.69*(V)$);
    
    \coordinate (GapX) at ($0.15*(U)$);
    \coordinate (GapY) at ($0.20*(V)$);
    
    \expandafter\newcommand\csname #4ShapesGrid\endcsname[4]
    {
        \drawShapes{$(##1) + ##2*#1*(U) + {##2*(#1 + 1)}*(GapX) + 
                             ##3*#2*(V) + {##3*(#2 + 1)}*(GapY)$}
                   {U}{V}{GapX}{GapY}{#5}{##4}
    }
}

\newcommand{\defineSmallShapes}[2]{\defineShapes{#1}{#2}{0.065}{small}{pfem_small}}
\newcommand{\defineMediumShapes}[2]{\defineShapes{#1}{#2}{0.13}{medium}{pfem_medium}}
\newcommand{\defineLargeShapes}[2]{\defineShapes{#1}{#2}{0.26}{large}{pfem_large}}
\newcommand{\defineTensorProductShapes}[2]{\defineShapes{#1}{#2}{0.209}{tensorproduct}{tensorproduct}}

% For space-time plots in chapter 2
\def\colorA{red}
\def\colorB{violet}
\def\colorC{blue}

% Setup grids of shape function grids over three hierarchies for mlhp-example
\newcommand{\prepareMlhpPlots}
{
    \tikzset{GridStyle/.style={semithick, line cap=round, line join=round}}
    \tikzset{DashStyle/.style={GridStyle, gray, densely dashed}}

    \def\gap{0.15}
    \def\zoom{1.3}

    \newcommand{\cellWidth}{0.056384739*478pt}
    \newcommand{\PictureWidth}[2]{##1/(##2 + (##2 + 1)*\gap)}
  
    \newcommand{\UVector}[1]{{##1}, 0}
    \newcommand{\VVector}[1]{{0.2*##1}, {0.75*##1}}
      
    \newcommand{\PictureU}[2]{\UVector{\PictureWidth{##1}{##2}}}
    \newcommand{\PictureV}[2]{\VVector{\PictureWidth{##1}{##2}}}
    
    % Direction vectors 
    \coordinate (U) at (\UVector{\cellWidth});
    \coordinate (V) at (\VVector{\cellWidth});
    
    \coordinate (UP0) at (\PictureU{4*\cellWidth}{4});
    \coordinate (VP0) at (\PictureV{4*\cellWidth}{4});
    
    \coordinate (UP1) at (\PictureU{2*\cellWidth}{3});
    \coordinate (VP1) at (\PictureV{2*\cellWidth}{3});
    
    \coordinate (UP2) at (\PictureU{\zoom*\cellWidth}{2});
    \coordinate (VP2) at (\PictureV{\zoom*\cellWidth}{2});
    
    % Grid positions
    \coordinate (G0) at (0, 0);
    \coordinate (G1) at ($7.0*([rotate=90]U) + (G0)$);
    \coordinate (G2) at ($6.5*([rotate=90]U) + (G1)$);

    \newcommand{\mlhpShapesGridA}[3]{
        \drawShapes{$(G0) + ##1*4*(U) +##2*4*(V)$}{UP0}{VP0}
            {$\gap*(UP0)$}{$\gap*(VP0)$}{shapesA}{##3}}
    
    \newcommand{\mlhpShapesGridB}[3]{
        \drawShapes{$(G1) + ##1*2*(U) +##2*2*(V)$}{UP1}{VP1}
            {$\gap*(UP1)$}{$\gap*(VP1)$}{shapesB}{##3}}
    
    \newcommand{\mlhpShapesGridC}[3]{
        \drawShapes{$(G2) + {\zoom*(##1 - 4) + 4}*(U) + {\zoom*(##2 - 4) + 4}*(V)$}
            {UP2}{VP2}{$\gap*(UP2)$}{$\gap*(VP2)$}{shapesC}{##3}}

    % Mask positions 
    \coordinate (M0) at ($(G0) + 10.8*(U)$);
    \coordinate (M1) at ($(G1) + 10.8*(U)$);
    \coordinate (M2) at ($(G2) + 10.8*(U)$);
    
    \coordinate (VV) at ($(V-|U) - (U)$);
    
    \coordinate (R) at ([rotate=-90]VV);
    \coordinate (S) at (VV);
    \coordinate (r) at ($0.62*(R)$);
    \coordinate (s) at ($0.62*(S)$);
    
    \newcommand\drawMask[4]{\mlhpMatrix{$(##1) + ##2*(R) + ##3*(S)$}{r}{s}{##4}}
}

